Procedure MainMenuHelp;
{ Write help information on the screen }
  Begin { Procedure MainMenuHelp }
    Window(1,1,80,25); { Set to full screen }
    Row := 1; { For procedure memorywrite }
    Col := 1;
    ClrScr;
    ConOutPtr := Ofs(MemoryWrite); { Activate screen output driver }
    Write(#13); { This writes a blank line }
    Write('Hbase is an on-line version of the Herschel catalog of deep sky objects.',#13);
    Write('Users are encouraged to distribute the program freely on a non-profit basis',#13);
    Write('only. Please direct suggestions or questions to the author at this address:',#13);
    Write(#13);
    Write('                           Gary D. Williams',#13);
    Write('                           Rt. 1, Box 138C',#13);
    Write('                           Morgan, Utah 84050',#13);
    Write(#13);
    Write('Special thanks is in order to Dennis Donnelly, who painstakingly keyed the',#13);
    Write('entire data file, and made it available for this project. Thanks also to',#13);
    Write('Gary Liptrot, who helped with adding the constellation information.',#13);
    Write(#13,#13);
    Write('  As far as how to use the program is concerned, hands-on experience is the',#13);
    Write('only real way to become proficient. The basic idea is this: When the main menu',#13);
    Write('first comes up, the top line tells you that there are currently 2510 objects',#13);
    Write('selected. Your task is to narrow down this list, selecting only those objects',#13);
    Write('that match your current season, location, or interests.',#13);
    Write(#13,#13,#13,#13,#13,'                     Press the space bar to continue');
    WaitForSpace;
    ClrScr;
    Row := 1;
    Col := 1;
    Write(#13,'You do this through the 7 indented selection options. These menus will allow',#13);
    Write('you to select out only those objects that match what you are after. (you can',#13);
    Write('select particular constellations, ranges of R.A. etc.) You can select from',#13);
    Write('any or all of the 7 select options, and you can return to an option as often',#13);
    Write('as you like to change what you have already entered. The whole idea here is to',#13);
    Write('work up a sub-file containing a manageable number of objects. You can always',#13);
    Write('type "E" to examine the status of your selections so far. When you are done',#13);
    Write('with all your selections, you must sort your data. The sort is where all of',#13);
    Write('the objects that match your selections are pulled from the main catalog.',#13);
    Write('When the sort is complete, you are returned to the main menu, where you can',#13);
    Write('view, print, or precess your new list. You can also select the new list down',#13);
    Write('further, re-selecting and re-sorting as often as you like, narrowing down',#13);
    Write('your choices as you go. When you finally type I to initialize, you will be once',#13);
    Write('more back to an empty file with the select values set to select all objects.',#13);
    Write('The program assumes that with each successive select-and-sort, you will want',#13);
    Write('to narrow down further what you have already selected. On occasion though, you',#13);
    Write('will want to expand on your current selections, adding to what you already',#13);
    Write('have. To add new object types or Herschel classes, you can toggle the',#13);
    Write('expansion on, which will allow you to do this. Expansion will stay on until',#13);
    Write('you toggle it off or do an initialize.',#13);
    Write(#13,#13,#13,'                     Press the space bar to continue');
    WaitForSpace;
    ClrScr;
    Row := 1;
    Col := 1;
    Write(#13,'  Here is a sample run:',#13);
    Write('  You are about to go out and do some telescopic observing, so you will need a',#13);
    Write('list of objects to try for. You begin by selecting a range of R.A. that matches',#13);
    Write('the current season. You may want to concentrate on star clusters tonight, so',#13);
    Write('you select object types for open clusters, globulars, and clusters/nebulae.',#13);
    Write('You then sort these selections by constellation, and view the result on the',#13);
    Write('screen. There are more clusters than you could begin to see in a night, so you',#13);
    Write('select further, asking for only a particular couple of constellations. After',#13);
    Write('re-sorting, you precess the listing to the current epoch, and print it. This',#13);
    Write('whole process takes less than a minute, and you''re set with a customized,',#13);
    Write('disposable observing list.',#13);
    Write(#13);
    Write('Misc. hints for using Hbase follow.',#13);
    Write(#13);
    Write('All possible keystrokes for the menus are highlighted. If you are not seeing',#13);
    Write('this, adjust your brightness or contrast!',#13);
    Write(#13);
    Write('The epoch of the catalog is 1975.0',#13);
    Write(#13,#13,#13,#13,#13,'                     Press the space bar to continue');
    WaitForSpace;
    ClrScr;
    Row := 1;
    Col := 1;
    Write(#13,'When you select the View option, the following keys apply:',#13);
    Write('  Page Up / Page Down.',#13);
    Write('  Home : to top of list.',#13);
    Write('  End  : to end of list.',#13);
    Write('  "S"  : seek record of a given sequence number.',#13);
    Write('  "E"  : skip halfway from current position to end of file.',#13);
    Write('  "B"  : skip halfway from current position to beginning of file.',#13);
    Write('  "Q"  : quit the viewer and return to the main menu.',#13);
    Write(#13);
    Write('You may want to sort and print the entire catalog at least once. Be warned that',#13);
    Write('it will go for about 45 pages.',#13);
    Write(#13);
    Write('Objects listed at magnitude 0.0 have unknown magnitudes. Likewise, any other',#13);
    Write('questionable values of 0 are probably unknown.',#13);
    Write(#13);
    Write('When you enter the constellation selection menu when all constellations are',#13);
    Write('selected (as immediately after an initialize), the program will assume that you',#13);
    Write('intend to select one or more constellations so it will delete all constellations',#13);
    Write('from consideration for you. If you select nothing, then the program will add',#13);
    Write('them all back for you. Whenever one or more, but not all constellations are',#13);
    Write('selected, the menu will reflect the current status, and your selections will',#13);
    Write('remain unchanged.',#13);
    Write(#13,'                 Press the space bar to return to the main menu',#13);
    WaitForSpace;
    ConOutPtr := AuxOutPtr; { De-activate screen output driver }
  End; { Procedure MainMenuHelp }
